=== debian/changelog ===
vulkan-tools (1.3.268.0+dfsg1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Bump debhelper from old 12 to 13.
    + debian/rules: Drop --fail-missing argument to dh_missing, which is now the
      default.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Timo Aaltonen ]
  * New upstream release.
  * watch: Updated to use the new tag naming.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 03 Nov 2023 11:01:02 +0200
